// #autoload
// #name = IsaSwitch
// #version = 1.1
// #date = June 7th, 2002
// #author = <spush><color:ffff00></a><a:tribe	The Ministry>min <color:ffffff><a:player	TruSoulja>TruSoulja</a><spop>
// #warrior = TruSoulja
// #email = trusoulja@zbzoom.net
// #ICQ = 11108946
// #web = http://www.t2-ministry.com/
// #description = Allows the player to have a button that will switch to a weapon based on loadout.
// #status = Beta
// #readme = scripts/trusoulja/isreadme.txt

//-----create the huds
function createIsaSwitchHud() {
  exec("gui/IsaSwitch.gui");

  // add hudmover support
	if(isObject(HM) && isObject(HudMover)) {
		HudMover::addHud(IsaSwitch, "IsaSwitch Hud");
  }

  // add to playgui
  PlayGUI.add(IsaSwitch);

  // position
  if ($hudposIsaSwitch $= "" || $hudposIsaSwitch $= "0 0") {
    %isWidth = getWord(IsaSwitch.extent, 0);
    %isHeight = getWord(IsaSwitch.extent, 1);
    %pgWidth = getWord(PlayGUI.extent, 0);
    %pgHeight = getWord(PlayGUI.extent, 1);

    %isLeft = mfloor(%pgWidth / 2) - mfloor(%isWidth / 2);
    %isTop = mfloor(%pgHeight / 2) - mfloor(%isHeight / 2);

    IsaSwitch.position = %isLeft SPC %isTop;
  } else
    IsaSwitch.position = $hudposIsaSwitch;


  // setup defaults
  IsaSwitch.currentFavorite = $Pref::FavCurrentSelect;
  IsaSwitch.isOpen = false;

  // exec prefs file to reload old settings
  if (isFile("prefs/truprefs.cs"))
    exec("prefs/truprefs.cs");
}

function IsaSwitch::cancelSetup(%this) {
  %this.open(0);
}

function IsaSwitch::saveSetup(%this) {
  %selected = IsaSwitchLoadoutMenu.getSelected();
  %weapon = IsaSwitchWeaponMenu.getSelected();
  $TruPref::isaSwitchWeapon[%selected] = %weapon;
  export("$TruPref::*", "prefs/truprefs.cs", false);

  // close
  %this.open(0);
}

function IsaSwitch::open(%this, %val) {
  if (%val) {
    %this.loadValues();
    canvas.pushDialog(IsaSwitch);
    cursorOn();
    %this.isOpen = true;
  } else {
    canvas.popDialog(IsaSwitch);
    cursorOff();
    %this.isOpen = false;
  }
}

function IsaSwitch::loadValues(%this) {
  // clear menus
  IsaSwitchLoadoutMenu.clear();

  // fill loadout menu with favorite names
  for (%i = 0;  %i <= 19; %i++) {
    IsaSwitchLoadoutMenu.add($pref::FavNames[%i], %i);
  }
  IsaSwitchLoadoutMenu.setSelected($pref::FavCurrentSelect);

  // fill weapon menu with valid choices
  %this.loadWeapons();

}

function IsaSwitchLoadoutMenu::onSelect(%this, %val) {
  IsaSwitch::loadWeapons();
}

function IsaSwitch::loadWeapons(%this) {
  %currLoadout = IsaSwitchLoadoutMenu.getSelected();
  IsaSwitchWeaponMenu.clear();

  %currCt = 0;
  %currValue = $InvWeapon[%currCt];
  while (%currValue !$= "") {
    IsaSwitchWeaponMenu.add(%currValue, %currCt);
    %currCt++;
    %currValue = $InvWeapon[%currCt];
  }
  %currFav = $TruPref::isaSwitchWeapon[%currLoadout];
  if (%currFav $= "")
    %currFav = 3;        // default to spinfusor
  IsaSwitchWeaponMenu.setSelected(%currFav);
}

function IsaSwitch::gotoWeapon(%this) {
  %currentFav = IsaSwitch.currentFavorite;
  %weapon = $TruPref::isaSwitchWeapon[%currentFav];
  switch$ (%weapon) {
    case "0":
      useBlaster(1);
    case "1":
      usePlasma(1);
    case "2":
      useChaingun(1);
    case "3":
      useDisc(1);
    case "4":
      useGrenadeLauncher(1);
    case "5":
      useSniperRifle(1);
    case "6":
      useELFGun(1);
    case "7":
      useMortar(1);
    case "8":
      useMissileLauncher(1);
    case "9":
      useShockLance(1);
    default:
      useDisc(1);
  }
}

function toggleIsaSwitchConfig(%val) {
  if (!%val)
    if (IsaSwitch.isOpen)
      IsaSwitch.open(0);
    else
      IsaSwitch.open(1);
}

function isaSwitchWeapon(%val) {
  if (%val)
    IsaSwitch::gotoWeapon();
}

package IsaSwitchPkg {
  // add the bindings to the optionsdlg
  function OptionsDlg::onWake(%this) {
   	if (!$IsaSwitchBound) {
  		$RemapName[$RemapCount] = "Isa Switch Config";
  		$RemapCmd[$RemapCount] = "toggleIsaSwitchConfig";
  		$RemapCount++;

  		$RemapName[$RemapCount] = "Isa Switch";
  		$RemapCmd[$RemapCount] = "isaSwitchWeapon";
  		$RemapCount++;

      $IsaSwitchBound = true;
  	}

  	parent::onWake(%this);
  }

  // add the IsaSwitch hud whenever playgui opens
  function PlayGui::onWake(%this) {
    if (!$IsaSwitchAdded) {
      createIsaSwitchHud();
      $IsaSwitchAdded = true;
    }

    parent::onWake(%this);
  }

  // hide IsaSwitch before PlayGUI is hidden
  function PlayGui::onSleep(%this) {
    echo("\c4sleepy sleepy...");
    if (IsaSwitch.isOpen)
      IsaSwitch.open(0);

    parent::onWake(%this);
  }

	function clientCmdSetStationKeys(%inStation) {
    parent::clientCmdSetStationkeys(%inStation);

    IsaSwitch.currentFavorite = $Pref::FavCurrentSelect;
  }
};

$IsaSwitchBound = false;
$IsaSwitchAdded = false;
activatePackage(IsaSwitchPkg);
